import java.util.Comparator;

public class Ex6GenMeth {

/**
 * Write a generic static method to find largest element in an array.
 * Then use the method on the Integer type.
 **/

public static <T extends Comparable<? super T>> T findMax( T [ ] a ) {
	int maxIndex = 0;

	for( int i = 1; i < a.length; i++ )
		if( a[i].compareTo( a[maxIndex] ) > 0 ) maxIndex = i;

	return a[ maxIndex ];
}


public static <T> T findMax( T [ ] a, Comparator<T> comparator) {
	int maxIndex = 0;

	for( int i = 1; i < a.length; i++ )
		if(comparator.compare(a[i],a[maxIndex]) > 0) maxIndex = i;

	return a[ maxIndex ];
}

/**
  * Write a generic method which accepts an array and returns the
  * smallest item. Then use the method on the String type.
 **/

public static <T extends Comparable<? super T>> T findMin( T [ ] a ) {
	int minIndex = 0;

	for( int i = 1; i < a.length; i++ )
		if( a[i].compareTo( a[minIndex] ) < 0 ) minIndex = i;

	return a[ minIndex ];
}


public static <T> T findMin( T [ ] a, Comparator<T> comparator) {
	int minIndex = 0;

	for( int i = 1; i < a.length; i++ )
		if( comparator.compare(a[i],a[minIndex]) < 0 ) minIndex = i;

	return a[ minIndex ];
}


public static void main(String[] args) {
	Integer[] arrayOfInt = {13, 15, 2, 100, 45};
	System.out.print("Array of integers (increasing order): ");
	Integer x = Ex6GenMeth.<Integer>findMax(arrayOfInt);
	Integer y = Ex6GenMeth.<Integer>findMin(arrayOfInt);
	for (Integer i: arrayOfInt) System.out.print(i + "; ");
	System.out.println("\nMax: " + x);
	System.out.println("Min: " + y);
	
	System.out.println();
	System.out.print("Array of integers (decreasing order): ");
	Comparator<Integer> c = new Integer_Decr();
	x = Ex6GenMeth.<Integer>findMax(arrayOfInt, c);
	y = Ex6GenMeth.<Integer>findMin(arrayOfInt, c);
	for (Integer i: arrayOfInt) System.out.print(i + "; ");
	System.out.println("\nMax: " + x);
	System.out.println("Min: " + y);
	
	
	System.out.println();
	System.out.print("Array of strings (lexicographic order): ");
	String[] arrayOfString = {"Exam", "Algorithm", "Laboratory", "Core", "Class"};
	String s = Ex6GenMeth.<String>findMin(arrayOfString);
	String t = Ex6GenMeth.<String>findMax(arrayOfString);
	for (String i: arrayOfString) System.out.print(i + "; ");
	System.out.println("\nMax: " + t);
	System.out.println("Min: " + s);	
	
	
	System.out.println();
	System.out.print("Array of strings (string lengths order): ");
	Comparator<String> cs = new String_byLength();
	s = Ex6GenMeth.<String>findMin(arrayOfString, cs);
	t = Ex6GenMeth.<String>findMax(arrayOfString, cs);
	for (String i: arrayOfString) System.out.print(i + "; ");
	System.out.println("\nMax: " + t);
	System.out.println("Min: " + s);	
	
	
}//end-main
	

} //end-class


class Integer_Decr implements Comparator<Integer>{
	public int compare(Integer a, Integer b) {
		return - a.compareTo(b);
	}
}

class String_byLength implements Comparator<String>{
	public int compare(String a, String b) {
		if (a.length() < b.length()) return -1;
		else if (a.length() > b.length()) return 1;
		else return a.compareTo(b);
	}
}
